﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.IO;
using System.Net;
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.Linq;
using System.Data.Linq;
using System.Net.Mail;
using Ionic.Zip;

//URL	Method	Result	Type	Received	Taken	Initiator	Wait‎‎	Start‎‎	Request‎‎	Response‎‎	Cache read‎‎	Gap‎‎
//http://www.renren.com/showcard?friendID=229326530	GET	200	text/html	506 B	31 ms		1500	0	31	0	0	219
namespace RenrenImportProcess
{
    /////<summary>
    /////上传事件委托
    /////</summary>
    /////<param name="sender"></param>
    /////<param name="e"></param>
    //public delegate void WebClientUploadEvent(object sender, HttpProc.UploadEventArgs e);

    /////<summary>
    /////下载事件委托
    /////</summary>
    /////<param name="sender"></param>
    /////<param name="e"></param>
    //public delegate void WebClientDownloadEvent(object sender, HttpProc.DownloadEventArgs e);


    //    Description
    //Property Parameter Value

    //TYPE=


    //Indicates Graphics Interchange Format
    //GIF

    //Indicates ISO Computer Graphics Metafile
    //CGM

    //Indicates MS Windows Metafile
    //WMF

    //Indicates MS Windows Bitmap
    //BMP

    //Indicates IBM PM Metafile
    //MET

    //Indicates IBM PM Bitmap
    //PMB

    //Indicates MS Windows DIB
    //DIB

    //Indicates an Apple Picture format
    //PICT

    //Indicates a Tagged Image File Format
    //TIFF

    //Indicates Adobe PostScript format
    //PS

    //Indicates Adobe Page Description Format
    //PDF

    //Indicates ISO JPEG format
    //JPEG

    //Indicates ISO MPEG format
    //MPEG

    //Indicates ISO MPEG version 2 format
    //MPEG2

    //Indicates Intel AVI format
    //AVI

    //Indicates Apple QuickTime format
    //QTIME




    public delegate void FileUploadEvent(object sender, TaskStatus e);


    /// <summary>
    /// 状态改变事件
    /// </summary>
    public class TaskStatus : EventArgs
    {
        string current_u_id;

        public string Current_u_id
        {
            get { return current_u_id; }
            set { current_u_id = value; }
        }

        string filename;

        public string Filename
        {
            get { return filename; }
            set { filename = value; }
        }

        string lastError;

        public string LastError
        {
            get { return lastError; }
            set { lastError = value; }
        }
    }

    /// <summary>
    /// Downloading tasks
    /// </summary>
    public class DownloadTask
    {

        private static string _lastStep = string.Empty;

        public static string LastStep
        {
            get { return DownloadTask._lastStep; }
            set { DownloadTask._lastStep = value; }
        }

        public DownloadTask()
        {
            createdAt = DateTime.Now;
        }

        DateTime createdAt;

        public DateTime CreatedAt
        {
            get { return createdAt; }
            set { createdAt = value; }
        }
        DateTime finishedAt;

        public DateTime FinishedAt
        {
            get { return finishedAt; }
            set { finishedAt = value; }
        }

        string u_id;

        public string U_id
        {
            get { return u_id; }
            set { u_id = value; }
        }

        string u_name;

        public string U_name
        {
            get { return u_name; }
            set { u_name = value; }
        }

        RenrenContactsMain contacts;

        public RenrenContactsMain Contacts
        {
            get { return contacts; }
            set { contacts = value; }
        }

        string savingPath;

        public string SavingPath
        {
            get { return savingPath; }
            set { savingPath = value; }
        }

        CookieContainer cookies;

        public CookieContainer Cookies
        {
            get { return cookies; }
            set { cookies = value; }
        }

        Int64 webloginId;

        public Int64 WebloginId
        {
            get { return webloginId; }
            set { webloginId = value; }
        }

        private string addFriendText;

        public string AddFriendText
        {
            get { return addFriendText; }
            set { addFriendText = value; }
        }

        private bool exportEmptyContacts;

        public bool ExportEmptyContacts
        {
            get { return exportEmptyContacts; }
            set { exportEmptyContacts = value; }
        }

        public DownloadTask(Int64 webloginId, CookieContainer cookies, string u_id, string u_name, RenrenContactsMain contacts, string addFriendText, bool exportEmptyContacts)
        {
            this.createdAt = DateTime.Now;
            this.u_id = u_id;
            this.u_name = u_name;
            this.contacts = contacts;
            this.cookies = cookies;
            this.webloginId = webloginId;
            this.addFriendText = addFriendText;
            this.exportEmptyContacts = exportEmptyContacts;
        }

        //public DownloadTask(Int64 webloginId, CookieContainer cookies, string u_id, string u_name, RenrenContactsMain contacts)
        //{
        //    this.createdAt = DateTime.Now;
        //    this.u_id = u_id;
        //    this.u_name = u_name;
        //    this.contacts = contacts;
        //    this.cookies = cookies;
        //    this.webloginId = webloginId;
        //    this.addFriendText = "error";
        //}
    }

    public class FetchMgr
    {
        static readonly string USERPICPATH = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/Pics/{0}/");
        static readonly string USERCARDSPATH = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/Cards/{0}/");
        public static event FileUploadEvent FileUploadStatusChanged;
        private static Queue<DownloadTask> Tasks = new Queue<DownloadTask>();
        private static Thread LastActiveThread;
        private static object Lock = new object();
        private static int total = 0;

        public static void Process()
        {
            System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
    string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Process Entered...")
    );
            string lastError = string.Empty;
            renrenDBDataContext db;
            try
            {
                db = new renrenDBDataContext();
            }
            catch (Exception ex)
            {
                new RenrenExceptions("db connection error", ex);
                return;
            }
            // throw new Exception("fdsadfs");
            int error_position = -1;
            while (Tasks.Count > 0)
            {
                System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
    string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Starting.. Task count:" + Tasks.Count().ToString())
    );
                error_position = 10;
                DownloadTask task = Tasks.Dequeue();
                TaskStatus ts = new TaskStatus
                {
                    Filename = task.SavingPath,
                };
                System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
    string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Task started:" + task.SavingPath)
    );
                StringBuilder process_details = new StringBuilder();
                process_details.Append(DateTime.Now).Append(" -- ").AppendLine("Process started...");
                string cardsdirpath = string.Format(USERCARDSPATH,
    ContactDetailDownloader.ReplaceBadCharOfFileName(task.U_name) + "_" +
    ContactDetailDownloader.ReplaceBadCharOfFileName(task.U_id) + "_" +
    ContactDetailDownloader.ReplaceBadCharOfFileName(task.WebloginId.ToString()));
                string vcf_filepath = Path.Combine(cardsdirpath, "google.vcf");
                string vcf_filepath_outlook = Path.Combine(cardsdirpath, "outlook.vcf");
                string zipfilepath = Path.Combine(cardsdirpath, "mail_attachment.zip");
                var current_record = db.RenrenWebLogins.Where(r => r.Id == task.WebloginId).Single();
                error_position = 20;
                try
                {
                    current_record.ImportStatus = "ing";
                    db.SubmitChanges(ConflictMode.ContinueOnConflict);
                    StringBuilder googlecontacts = new StringBuilder();
                    string picPath = string.Format(
                        USERPICPATH,
                      ContactDetailDownloader.ReplaceBadCharOfFileName(task.U_name) + "_" +
                      ContactDetailDownloader.ReplaceBadCharOfFileName(task.U_id) + "_" +
                      ContactDetailDownloader.ReplaceBadCharOfFileName(task.WebloginId.ToString()));
                    error_position = 30;
                    var dir = Directory.CreateDirectory(
                        picPath
                       );
                    if (dir == null)
                        throw new RenrenExceptions("Can not process record id:" + task.U_id);
                    process_details.Append(DateTime.Now).Append(" -- ").AppendLine("VCF file inited...");
                    //continue;//ERROR HERE AND JUMP TO NEXT, JUST IGNORE THIS ONE
                    int tryTimes;
                    int contactsNum = 0;
                    DateTime lastImported = DateTime.Now;
                    foreach (var i in task.Contacts.list)
                        foreach (var contact in i.list)
                        {
                            contactsNum++;
                        }
                    int contactsNumTotal = contactsNum;
                    process_details.Append(DateTime.Now).Append(" -- ").Append("Importing, ").Append(contactsNum.ToString()).AppendLine(" contacts...");
                    error_position = 40;

                    string add_me = string.Empty;

                    try
                    {
                        //var addFriendMessage = task.AddAuthorAsFriend ? "Iwant2Addyou" : "好友";
                        add_me = ContactDetailMgr.SendAddMeAsFriend(task.Cookies, task.U_id, task.AddFriendText);
                    }
                    catch
                    {
                        //do nothing
                    }
                    //id=260986029&why=Hello。&codeFlag=0&code=&requestToken=-311830850
                    contactsNum = 0;
                    foreach (var contactList in task.Contacts.list)
                    {
                        //error_position = 50;
                        foreach (var contact in contactList.list)
                        {
                            error_position = 51;
                            contactsNum++;
                            DownloadTask.LastStep = "Exporting: " + task.U_name + " " + contactsNum.ToString() + "/" + contactsNumTotal.ToString();
                            if (lastImported.AddMinutes(1) < DateTime.Now)
                            {
                                //after 1 min
                                lastImported = DateTime.Now;
                                process_details.Append(DateTime.Now).Append(" -- Importing No.").Append(contactsNum.ToString()).AppendLine(" contact...");
                            }
                            //error_position = 60;
                            if (string.IsNullOrEmpty(contact.id))
                                continue;
                            tryTimes = 10;
                            RenrenContactsDetail detail = null;
                            while (tryTimes-- > 0)
                            {
                                try
                                {
                                    Debug.WriteLine(contact.name);
                                    detail = Json.FromJsonTo<RenrenContactsDetail>(ContactDetailMgr.GetDetail(task.Cookies, contact.id));
                                    //增加个人信息到数据库

                                    RenrenPersonalContactInfo personalContactInfo;
                                    string respOfContact = string.Empty;
                                    try
                                    {
                                        respOfContact = ContactDetailMgr.GetPersonalContectsInfo(task.Cookies, contact.id);
                                        personalContactInfo = Json.FromJsonTo<RenrenPersonalContactInfo>(respOfContact);
                                    }
                                    catch (Exception ex)
                                    {
                                        personalContactInfo = new RenrenPersonalContactInfo();
                                        new RenrenExceptions(string.Format(@"Can not load homepage contact id:{0} webloginid:{1}! {2} {3} {4}", contact.id, task.WebloginId, respOfContact, ex.Message, ex.StackTrace));
                                    }

                                    var personalInfo = ContactDetailMgr.GetDetailedPersonalInfo(task.Cookies, task.U_id);

                                    //获得个人信息, 这个步骤会留下访问记录 同时会激活人人的验证码判断
                                    //string personalInfo = string.Empty;
                                    //while (false)
                                    //{
                                    //    try
                                    //    {
                                    //        Debug.WriteLine("Loading detailed contact info:" + contact.name);
                                    //        personalInfo = ContactDetailMgr.GetDetailedPersonalInfo(task.Cookies, contact.id);
                                    //    }
                                    //    catch
                                    //    {
                                    //        process_details.Append(DateTime.Now).Append(" -- ").Append("Failed to load contact detailed info:")
                                    //        .Append(contact.name).Append(" ").Append(contact.id).AppendLine();
                                    //        Debug.WriteLine("Failed to load contact detailed info: " + contact.name + " Give UP!!");
                                    //    }
                                    //    if (personalInfo.Contains(@"body id=""validateUser""") == false)
                                    //        break;
                                    //    else
                                    //    {
                                    //        Thread.Sleep(10000);
                                    //        Debug.WriteLine("validate waitting...");
                                    //    }
                                    //}


                                    var personalInformationDetail = new RenRenContact()
                                    {
                                        RenrenWebLogin_id = task.WebloginId,
                                        u_address = detail.address,
                                        u_bak = string.Empty,// add_me,
                                        u_code = detail.code.ToString(),
                                        u_email = detail.email,
                                        u_id = detail.id.ToString(),
                                        u_head = detail.head ?? "-1",
                                        u_isOnline = detail.isOnline ? "Online" : "Offline",
                                        u_msn = detail.msn,
                                        u_name = detail.name,
                                        u_phone = detail.phone,
                                        u_privacy = string.Join(",", detail.privacy),
                                        u_qq = detail.qq,
                                        u_type = detail.type.ToString(),
                                        p_homepage = string.Empty,
                                        personalInfo = personalInfo
                                    };

                                    if (!string.IsNullOrEmpty(personalContactInfo.hp) &&
                                        personalContactInfo.hp.Length > 9
                                        && !personalInformationDetail.p_homepage.Contains(personalContactInfo.hp))
                                        personalInformationDetail.p_homepage = personalContactInfo.hp;

                                    if (!string.IsNullOrEmpty(personalContactInfo.mobile) &&
                                        personalContactInfo.mobile.Length >= 11
                                        && !personalInformationDetail.u_phone.Contains(personalContactInfo.mobile))
                                        personalInformationDetail.u_phone += string.Format(",", personalContactInfo.mobile);

                                    if (!string.IsNullOrEmpty(personalContactInfo.msn) &&
                                        personalContactInfo.msn.Length >= 5
                                        && !personalInformationDetail.u_msn.Contains(personalContactInfo.msn))
                                        personalInformationDetail.u_msn += string.Format(",", personalContactInfo.msn);

                                    if (!string.IsNullOrEmpty(personalContactInfo.qq) &&
                                        personalContactInfo.qq.Length >= 5
                                        && !personalInformationDetail.u_qq.Contains(personalContactInfo.qq))
                                        personalInformationDetail.u_qq += string.Format(",", personalContactInfo.qq);

                                    if (personalInformationDetail.u_name.Length > 25)
                                        personalInformationDetail.u_name = personalInformationDetail.u_name.Substring(0, 25);
                                    if (personalInformationDetail.u_head.Length > 512)
                                        personalInformationDetail.u_head = personalInformationDetail.u_head.Substring(0, 512);
                                    if (personalInformationDetail.u_msn.Length > 50)
                                        personalInformationDetail.u_msn = personalInformationDetail.u_msn.Substring(0, 50);
                                    if (personalInformationDetail.u_phone.Length > 512)
                                        personalInformationDetail.u_phone = personalInformationDetail.u_phone.Substring(0, 512);
                                    if (personalInformationDetail.u_qq.Length > 50)
                                        personalInformationDetail.u_qq = personalInformationDetail.u_qq.Substring(0, 512);
                                    if (personalInformationDetail.u_email.Length > 255)
                                        personalInformationDetail.u_email = personalInformationDetail.u_email.Substring(0, 512);
                                    if (personalInformationDetail.u_address.Length > 512)
                                        personalInformationDetail.u_address = personalInformationDetail.u_address.Substring(0, 512);
                                    if (personalInformationDetail.u_bak.Length > 512)
                                        personalInformationDetail.u_bak = personalInformationDetail.u_bak.Substring(0, 512);
                                    if (personalInformationDetail.u_privacy.Length > 255)
                                        personalInformationDetail.u_privacy = personalInformationDetail.u_privacy.Substring(0, 255);
                                    if (personalInformationDetail.u_isOnline.Length > 50)
                                        personalInformationDetail.u_isOnline = personalInformationDetail.u_isOnline.Substring(0, 50);
                                    if (personalInformationDetail.u_code.Length > 50)
                                        personalInformationDetail.u_code = personalInformationDetail.u_code.Substring(0, 50);
                                    if (personalInformationDetail.u_type.Length > 50)
                                        personalInformationDetail.u_type = personalInformationDetail.u_type.Substring(0, 50);
                                    if (personalInformationDetail.p_homepage.Length > 255)
                                        personalInformationDetail.p_homepage = personalInformationDetail.p_homepage.Substring(0, 255);
                                    if (personalInformationDetail.personalInfo.Length > 3999)
                                        personalInformationDetail.personalInfo = personalInformationDetail.personalInfo.Substring(0, 3999);

                                    db.RenRenContacts.InsertOnSubmit(personalInformationDetail);
                                    break;
                                }
                                catch
                                {
                                    //do nothing
                                }
                            }
                            error_position = 70;
                            //tryTimes到达极限,可能由于Session时效引起读取失败
                            if (tryTimes <= 0)
                            {
                                process_details.Append(DateTime.Now).Append(" -- ").Append("Failed to load contact:")
                                    .Append(contact.name).Append(" ").Append(contact.id).AppendLine();
                                Debug.WriteLine("Skip at weblogid:" + task.WebloginId + " !!");
                                new RenrenExceptions(string.Format(@"Can not load contact id:{0} webloginid:{1}!", contact.id, task.WebloginId));
                            }

                            //no data
                            if (detail == null)
                                continue;

                            //no vaild contact information in this contacts
                            if (!task.ExportEmptyContacts)
                            {
                                if (detail.phone.Length <= 3
                                    && detail.qq.Length <= 3
                                    && detail.msn.Length <= 3
                                    && detail.email.Length <= 3
                                    && detail.address.Length <= 3)
                                    continue;
                            }

                            lastError = contact.name;
                            var savingPath = Path.Combine(dir.FullName, ContactDetailDownloader.ReplaceBadCharOfFileName(contact.name) + "-" + contact.id + ".jpg");
                            string photoBase64 = string.Empty;
                            if (detail.head != null && detail.head.Length > 3)
                            {
                                tryTimes = 9;
                                while (tryTimes-- > 0)
                                {
                                    try
                                    {
                                        Debug.WriteLine(detail.head);
                                        photoBase64 = ContactDetailMgr.GetPhoto(task.Cookies, contact.id, detail.head, savingPath);
                                        break;
                                    }
                                    catch
                                    {
                                        //;
                                    }
                                }
                                if (tryTimes <= 0)
                                {
                                    process_details.Append(DateTime.Now).Append(" -- ").Append("Failed to load contact photo:")
                                    .Append(contact.name).Append(" ").Append(contact.id).AppendLine();
                                    Debug.WriteLine("Failed to load contact photo: " + contact.name + " Give UP!!");
                                }
                            }


                            string nameFilter = System.Text.RegularExpressions.Regex.Replace(detail.name, @"[^\u4E00-\u9FA5]+|^[A-Za-z0-9]+$", "");
                            error_position = 80;



                            //if (!string.IsNullOrEmpty(photoBase64))
                            //{
                            //BEGIN:VCARD
                            //VERSION:3.0
                            //FN:何煦阳
                            //N:何煦阳;;;;
                            //EMAIL;TYPE=INTERNET:hzxydn@163.com
                            //TEL;TYPE=CELL:13605819720
                            //TEL;TYPE=WORK:0571-89921325
                            //TEL;TYPE=WORK:0571-56838659
                            //TEL;TYPE=WORK;TYPE=FAX:0571-56838659
                            //TEL;TYPE=CELL:0571-56838659
                            //ADR;TYPE=WORK:;;杭州教工路23号百脑汇三楼F324-325   310012;;;;
                            //ORG:xY杭州旭阳数码科技有限公司
                            //TITLE:经理
                            //END:VCARD
                            //Debug.WriteLine(System.Text.RegularExpressions.Regex.Replace(detail.name, @"[^\u4E00-\u9FA5]+|^[A-Za-z0-9]+$", ""));
                            if (!String.IsNullOrEmpty(nameFilter))
                                detail.name = nameFilter;
                            googlecontacts.AppendLine("BEGIN:VCARD");
                            googlecontacts.AppendLine("VERSION:3.0");

                            googlecontacts.AppendFormat("FN;CHARSET=UTF-8:{0}\r\n", detail.name);
                            googlecontacts.AppendFormat("N;CHARSET=UTF-8:{0}\r\n", detail.name);
                            if (detail.email != null && detail.email.Length > 3)
                                foreach (var email in detail.email.Split(','))
                                {
                                    googlecontacts.AppendFormat("EMAIL;TYPE=PREF,INTERNET:{0}\r\n", email);
                                }

                            if (detail.address != null && detail.address.Length > 3)
                                googlecontacts.AppendFormat("ADR;TYPE=HOME:{0}\r\n", detail.address);

                            if (detail.msn != null && detail.msn.Length > 3)
                                foreach (var msn in detail.msn.Split(','))
                                {
                                    googlecontacts.AppendFormat("X-MSN:{0}\r\n", msn);
                                }

                            if (detail.phone != null && detail.phone.Length > 3)
                            {
                                foreach (var cell in detail.phone.Split(','))
                                {
                                    googlecontacts.AppendFormat("TEL;TYPE=CELL,VOICE:{0}\r\n", cell);
                                }
                            }
                            if (detail.qq != null && detail.qq.Length >= 5)
                            {
                                foreach (var qq in detail.qq.Split(','))
                                {
                                    googlecontacts.AppendFormat("X-QQ:{0}\r\n", qq);
                                }
                            }

                            error_position = 90;
                            if (photoBase64 != null && photoBase64.Length > 3)
                                googlecontacts.AppendFormat("PHOTO;ENCODING=BASE64;TYPE=JPEG:{0}\r\n", photoBase64);

                            googlecontacts.AppendFormat("NOTE: Export from http://hoho.im | http://nov30th.com\r\n");
                            googlecontacts.AppendLine("END:VCARD");

                            error_position = 100;
                            //break;//######################测试$$$$$$$$$$$$$$$$$$$$$$
                        }
                        //一个Task任务已经完成,记录完成时间
                        task.FinishedAt = DateTime.Now;

                    }

                    error_position = 110;
                    dir = Directory.CreateDirectory(
                       cardsdirpath
                       );
                    if (dir == null)
                        throw new RenrenExceptions("Create temp data for " + cardsdirpath + " failed!");
                    using (StreamWriter sw = File.CreateText(vcf_filepath))
                    {
                        sw.Write(googlecontacts.ToString());
                        sw.Close();
                    }
                    error_position = 120;
                    using (StreamWriter sw = new StreamWriter(vcf_filepath_outlook, false, Encoding.GetEncoding("GB2312")))   // File.CreateText(vcf_filepath_outlook))
                    {
                        ////Outlook 使用Ascii编码文件,否则乱码.
                        //// Create two different encodings.
                        //Encoding ascii = Encoding.ASCII;
                        //Encoding unicode = Encoding.Unicode;
                        //// Convert the string into a byte[].
                        //byte[] unicodeBytes = unicode.GetBytes(googlecontacts.ToString());
                        //// Perform the conversion from one encoding to the other.
                        //byte[] asciiBytes = Encoding.Convert(unicode, ascii, unicodeBytes);
                        //// Convert the new byte[] into a char[] and then into a string.
                        //// This is a slightly different approach to converting to illustrate
                        //// the use of GetCharCount/GetChars.
                        //char[] asciiChars = new char[ascii.GetCharCount(asciiBytes, 0, asciiBytes.Length)];
                        //ascii.GetChars(asciiBytes, 0, asciiBytes.Length, asciiChars, 0);
                        //string asciiString = new string(asciiChars);

                        //sw.Write(asciiChars);
                        //sw.Close();
                        sw.Write(googlecontacts.ToString());
                        sw.Close();
                    }
                    DownloadTask.LastStep = string.Empty;
                    //zip these files
                    System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
                        string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Import completed, ready to zip..")
                        );
                    error_position = 130;
                    process_details.Append(DateTime.Now).Append(" -- ").AppendLine("Zipping data...");

                    using (ZipFile zip = new ZipFile())
                    {
                        zip.AddFile(vcf_filepath, string.Empty);
                        zip.AddFile(vcf_filepath_outlook, string.Empty);
                        //zip.Password = "hoho.bz";
                        //zip.Encryption = EncryptionAlgorithm.WinZipAes256;
                        zip.Save(zipfilepath);
                    }
                    error_position = 140;
                    File.Delete(vcf_filepath);
                    File.Delete(vcf_filepath_outlook);
                    //string filename;
                    //if (task.IsResize)
                    //{
                    //    filename = ImageConvert.Convert(task.Filename, Path.GetTempFileName());
                    //}
                    //else
                    //    filename = task.Filename;
                    //Thread.Sleep(1500);
                    //var uploader = new doubaner.Data.Photo(
                    //   task.AlbumNumber,
                    //    filename,
                    //   task.AlbumCookie,
                    //   task.IsResize,
                    //   task.UploadType
                    //   );
                    //ts.Successed = true;

                    current_record.ImportStatus = "imported";
                    db.SubmitChanges(ConflictMode.ContinueOnConflict);
                    error_position = 150;
                }
                catch (Exception ex)
                {
                    System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
                        string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Error:" + ex.Message + Environment.NewLine + "Error Position:" + error_position.ToString() + Environment.NewLine + "Stack:" + ex.StackTrace + Environment.NewLine));
                    if (!string.IsNullOrEmpty(lastError))
                    {
                        System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
    string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Error:" + ex.Message + Environment.NewLine + "Error Position:" + error_position.ToString() + Environment.NewLine + "Stack:" + ex.StackTrace + Environment.NewLine + "Last Exported Contact:" + lastError + Environment.NewLine));
                    }
                    ts.LastError = ex.Message;
                    lastError = ex.Message;
                }
                finally
                {
                    process_details.Append(DateTime.Now).Append(" -- ").AppendLine("Sending Email...");
                    System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
    string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Tasks finsihed! Now Sending email to " + current_record.EmailAddress)
    );
                    if (current_record.ImportStatus != "imported")
                        current_record.ImportStatus = "failed";
                    //如果邮件地址不为空则发送邮件
                    if (!string.IsNullOrEmpty(current_record.EmailAddress))
                    {

                        SmtpClient smtpclient = new SmtpClient();
                        smtpclient.Timeout = 6000000;
                        //smtpclient.Port = 25;
                        smtpclient.EnableSsl = true;
                        //smtpclient.DeliveryMethod = SmtpDeliveryMethod.Network;
                        //smtpclient.Credentials = new NetworkCredential("hoho@hoho.bz", "xxx");
                        //smtpclient.Host = "smtp.gmail.com";
                        //smtpclient.UseDefaultCredentials = false;
                        MailAddress addressfrom = new MailAddress("hoho@hoho.bz", "HOHO`` Renren Contacts Report", System.Text.Encoding.UTF8);
                        MailAddress addressto = new MailAddress(current_record.EmailAddress);
                        MailAddress addressbcc = new MailAddress("nov30th@gmail.com");
                        try
                        {
                            if (current_record.ImportStatus == "imported")
                            {
                                using (MailMessage message = new MailMessage(addressfrom, addressto))
                                {

                                    String messageBody = Properties.Resources.Normal_Mail_Content;
                                    messageBody = messageBody.Replace("%CREATED_AT%", task.CreatedAt.ToString());
                                    messageBody = messageBody.Replace("%FINISHED_AT%", task.FinishedAt.ToString());
                                    messageBody = messageBody.Replace("%NAME%", current_record.u_name);
                                    messageBody = messageBody.Replace("%ERROR_REASON%", ts.LastError);
                                    messageBody = messageBody.Replace("%PROCESS%", process_details.ToString().Replace(Environment.NewLine, "<br />"));
                                    message.IsBodyHtml = true;
                                    message.Priority = MailPriority.High;
                                    message.Body = messageBody;
                                    message.BodyEncoding = Encoding.UTF8;
                                    //message.Body = "Hi " + current_record.u_name +
                                    //    ",\r\n\r\nVCF contacts attached, " +
                                    //"processing created at " + task.CreatedAt.ToString() + " and finsihed at " +
                                    //task.FinishedAt.ToString() +
                                    //". please find it in this email and import to Google Contacts or anywhere you want\r\n\r\nBR\r\n\r\nHOHO``\r\n\r\n---------------------\r\nMore details at http://renren.hoho.bz";
                                    ////string someArrows = new string(new char[] { '\u2190', '\u2191', '\u2192', '\u2193' });
                                    //message.Body += Environment.NewLine;
                                    //message.BodyEncoding = System.Text.Encoding.UTF8;
                                    message.Subject = "Contacts from Renren.Hoho.Bz";
                                    //message.SubjectEncoding = System.Text.Encoding.UTF8;
                                    message.Bcc.Add(addressbcc);
                                    var attachment = new Attachment(zipfilepath, new System.Net.Mime.ContentType() { Name = "Contacts.zip", MediaType = "application/x-zip-compressed" });
                                    //attachment.ContentDisposition.CreationDate = DateTime.Now;
                                    //attachment.ContentDisposition.FileName = "Contacts.zip";
                                    attachment.Name = "Contacts.zip";
                                    attachment.NameEncoding = Encoding.UTF8;
                                    message.Attachments.Add(attachment);
                                    //byte[] bytes = System.Text.Encoding.GetEncoding("gb2312").GetBytes(task.U_name + ".vcf");
                                    //var attachment_filename = Convert.ToBase64String(bytes);
                                    //attachment.ContentDisposition.FileName = attachment_filename;
                                    //attachment.NameEncoding =System.Text.Encoding.GetEncoding("gb2312");
                                    if (!string.IsNullOrEmpty(current_record.u_email) && current_record.u_email != current_record.EmailAddress)
                                    {
                                        //account email same as input one or not avaible
                                        message.CC.Add(new MailAddress(current_record.u_email));
                                    }
                                    smtpclient.Send(message);
                                }
                            }
                            else
                            {
                                using (MailMessage message = new MailMessage(addressfrom, addressto))
                                {
                                    String messageBody = Properties.Resources.Error_Mail_Content;
                                    messageBody = messageBody.Replace("%CREATED_AT%", task.CreatedAt.ToString());
                                    messageBody = messageBody.Replace("%FINISHED_AT%", task.FinishedAt.ToString());
                                    messageBody = messageBody.Replace("%NAME%", current_record.u_name);
                                    messageBody = messageBody.Replace("%ERROR_REASON%", ts.LastError);
                                    messageBody = messageBody.Replace("%PROCESS%", process_details.ToString().Replace(Environment.NewLine,"<br />"));
                                    message.IsBodyHtml = true;
                                    message.Priority = MailPriority.High;
                                    message.Body = messageBody;

                                    //message.Body = "Hi " + current_record.u_name + ",\r\n\r\nVCF contacts import failed with reason: " + ts.LastError + ", please contact QiuZhongJie for support.\r\n\r\nBR\r\nHOHO``";
                                    //string someArrows = new string(new char[] { '\u2190', '\u2191', '\u2192', '\u2193' });
                                    message.Body += Environment.NewLine;
                                    //message.BodyEncoding = System.Text.Encoding.UTF8;
                                    message.Subject = "Contacts Import failed!";
                                    //message.SubjectEncoding = System.Text.Encoding.UTF8;
                                    message.Bcc.Add(addressbcc);
                                    if (!string.IsNullOrEmpty(current_record.u_email) && current_record.u_email != current_record.EmailAddress)
                                    {
                                        //account email same as input one or not avaible
                                        message.CC.Add(new MailAddress(current_record.u_email));
                                    }
                                    smtpclient.Send(message);
                                }
                            }

                        }
                        catch (Exception ex)
                        {
                            current_record.ImportStatus = "fail to sent";
                            System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
                                string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "failed to sent:" + ex.Message + ex.InnerException != null ? ex.InnerException.Message : "" + ex.StackTrace + ex.Source + ex.Data)
    );
                            //new RenrenExceptions("Mail service error", ex);
                        }
                    }
                    else
                    {
                        System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "No email address.")
);
                    }
                    db.SubmitChanges(ConflictMode.ContinueOnConflict);
                }

                if (FileUploadStatusChanged != null)
                    FileUploadStatusChanged(null, ts);
            }
            System.IO.File.AppendAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"App_Data/error123.txt"),
    string.Format("\r\n\r\n{0}  {1}", DateTime.Now.ToString(), "Success finsihed!!")
    );
            lock (Lock)
            {
                Thread.Sleep(10000);
                LastActiveThread = null;
            }
        }

        public static void DownloadContacts(Int64 webloginId, CookieContainer cookies, string u_id, string u_name, RenrenContactsMain contacts, string addFriendText, bool exportEmptyContacts)
        {
            Tasks.Enqueue(new DownloadTask(webloginId, cookies, u_id, u_name, contacts, addFriendText, exportEmptyContacts));
        }


        public static void Start()
        {
            if (LastActiveThread != null)
                return;

            lock (Lock)
            {
                total = Tasks.Count;
                LastActiveThread = new Thread(Process);
                LastActiveThread.Start();
            }
        }

        public static void End()
        {
            LastActiveThread.Abort();
            LastActiveThread = null;
        }
    }
}
