﻿<%@ Page Title="Log in with your Renren account" Language="C#" MasterPageFile="~/Site.master"
    AutoEventWireup="true" CodeFile="Login.aspx.cs" Inherits="Account_Login" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <h2>
        输入你的用户名和密码开始导出过程.
    </h2>
    <p>
        功能限制：为保证该小工具不影响服务器主要运行目的, 一个账户在12小时内只能导出一次。
    </p>
    <asp:Login ID="LoginUser" runat="server" EnableViewState="false" RenderOuterTable="false"
        OnLoggingIn="LoginUser_LoggingIn">
        <LayoutTemplate>
            <span class="failureNotification">
                <asp:Literal ID="FailureText" runat="server"></asp:Literal>
            </span>
            <asp:ValidationSummary ID="LoginUserValidationSummary" runat="server" CssClass="failureNotification"
                ValidationGroup="LoginUserValidationGroup" />
            <div class="accountInfo">
                <fieldset class="login">
                    <legend>Renren.Com Account Information</legend>
                    <p>
                        <asp:Label ID="UserNameLabel" runat="server" AssociatedControlID="UserName">Renren网登录名(手机,邮件,用户名均可)</asp:Label>
                        <asp:TextBox ID="UserName" runat="server" CssClass="textEntry"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="UserNameRequired" runat="server" ControlToValidate="UserName"
                            CssClass="failureNotification" ErrorMessage="User Name is required." ToolTip="User Name is required."
                            ValidationGroup="LoginUserValidationGroup">*</asp:RequiredFieldValidator>
                    </p>
                    <p>
                        <asp:Label ID="PasswordLabel" runat="server" AssociatedControlID="Password">Renren网密码</asp:Label>
                        <asp:TextBox ID="Password" runat="server" CssClass="passwordEntry" TextMode="Password"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="PasswordRequired" runat="server" ControlToValidate="Password"
                            CssClass="failureNotification" ErrorMessage="Password is required." ToolTip="Password is required."
                            ValidationGroup="LoginUserValidationGroup">*</asp:RequiredFieldValidator>
                    </p>
                    <p>
                        <asp:Label ID="EmailLabel" runat="server" AssociatedControlID="Email">接收结果的邮件地址</asp:Label>
                        <asp:TextBox ID="Email" runat="server" CssClass="textEntry"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="EmailRequired" runat="server" ControlToValidate="Email"
                            CssClass="failureNotification" ErrorMessage="Email is required." ToolTip="Email is required."
                            ValidationGroup="LoginUserValidationGroup">*</asp:RequiredFieldValidator>
                    </p>
                    <p>
                        <img id="_imageVerifyCode" src="" alt="人人网验证码" />
                        <script type="text/javascript">
                            document.getElementById("_imageVerifyCode").src = 'VerifyImage.aspx?t=' + Math.random();
                        </script>
                        <br />
                        输入图片上的验证码<br /><input type="text" id="icode" name="icode" class="textEntry" />
                    </p>
                    <%--                    <asp:CheckBox ID="_chkbtn_remove_memo" runat="server" Text="" />
                    <asp:Label ID="_label_remove_memo" runat="server" AssociatedControlID="_chkbtn_remove_memo" CssClass="inline">移除名片备注中信息</asp:Label>--%>
                    <%--<input type="checkbox" name="addme" id="addme" value="true" disabled="disabled" />--%>
                    <%--                    <label for="addme" id="ctl00_MainContent_LoginUser__label_addme" class="inline">添加作者为好友
                    </label>--%>
                    <p>
                        <asp:CheckBox ID="exportvaildonly" runat="server" Checked="False" />
                        <asp:Label ID="_label_exportvaildonly" runat="server" AssociatedControlID="exportvaildonly" CssClass="inline">只导出有联系方式的联系人</asp:Label></p><p>
                        <asp:CheckBox ID="addmea" runat="server" Checked="True" />
                        <asp:Label ID="_label_addme" runat="server" AssociatedControlID="addmea" CssClass="inline">添加作者为好友以便联系</asp:Label>
                    </p>
                    <%--                  <p>
                        <asp:CheckBox ID="RememberMe" runat="server"/>
                        <asp:Label ID="RememberMeLabel" runat="server" AssociatedControlID="RememberMe" CssClass="inline">Keep me logged in</asp:Label>
                    </p>--%>
                </fieldset>
                <center>
                    <p class="submitButton">
                        <asp:Button ID="LoginButton" runat="server" CommandName="Login" Text="执行导出" ValidationGroup="LoginUserValidationGroup"
                            Style="font-size: x-large; height: 40px; width: 220px; margin-top: 0px; font-family: 'Microsoft YaHei UI'" />
                    </p>
                </center>
            </div>
        </LayoutTemplate>
    </asp:Login>
</asp:Content>
