﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeFile="Default.aspx.cs" Inherits="_Default" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
    <title>Renren.com Contacts Export 人人网通讯录导出工具</title>
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <h2>欢迎使用人人网通讯录导出工具</h2>
    <p>
        导入步骤说明会包含在邮件，也可以<a href="http://hoho.im/blog/post/renren_import_contacts_xiaonei.html" target="_blank">点击这里
        </a>看使用说明.
    </p>
    <p>
        点击"Log In / 登入"开始人人网通讯录导出过程. 作为一个本人自开发自用的小程序，该导出过程及信息保密。无广告，除你收到一封邮件外，无任何其他操作。<br />
    </p>
    <p>
        关于这个工具的任何问题你也可以通过邮件的方式或QQ/微信联系我. nov30th@gmail.com QQ:2460739 (注明理由)
    </p>
    <p>
        该导出的数据支持各种手机以及电脑终端和非智能机设备: IPhone, Android, Symbian, Windows Mobile, IPod, Windows,
        Linux, IPad, etc...
    </p>
    <p>
        已经升级支持Renren网验证码。<br />
        （全球唯一可用的人人通讯录导出小工具）
    </p>
    <p>
        最新10位导出状态:
    </p>
    <p>当前/最后系统进度: <%=RenrenImportProcess.DownloadTask.LastStep %></p>
    <table>
        <tr>
            <td>名称 </td>
            <td>开始时间 </td>
            <td>当前状态 </td>
        </tr>
        <% 
            var renrenDB = new renrenDBDataContext();
            var newList = renrenDB.RenrenWebLogins.OrderByDescending(d => d.LoginAt).Take(10);
            foreach (RenrenWebLogin item in newList)
            {
        %><tr>
            <td>
                <%=item.u_name%>
            </td>
            <td>
                <%=item.LoginAt%>
            </td>
            <td>
                <%
                switch (item.ImportStatus)
                {
                    case "imported":
                        Response.Write("已导出并发送");
                        break;
                    case "failed":
                        Response.Write("导出中遇到错误!");
                        break;
                    case "not yet":
                        Response.Write("准备开始...");
                        break;
                    case "ing":
                        Response.Write("导出执行中...");
                        break;
                    case "stop by app restart":
                        Response.Write("数据初始化异常,请重试!");
                        break;
                }
                %>
            </td>
        </tr>
        <%} %>
    </table>
    <br />
    <%--    <div>
        <script type="text/javascript" src="http://widget.renren.com/js/rrshare.js"></script>
        <a name="xn_share" onclick="shareClick()" type="button_large" href="javascript:;">
        </a>
        <script type="text/javascript">
            function shareClick() {
                var rrShareParam = {
                    resourceUrl: 'http://renren.hoho.im/',	//分享的资源Url
                    pic: 'http://hoho.im/favicon.png',		//分享的主题图片Url
                    title: '支持各种手机的人人通讯录导出工具',		//分享的标题
                    description: '由裘中杰同学提供的人人通讯录导出工具，一个步骤导出头像,手机,Email,QQ,MSN等联系方式到各种手机电脑设备支持的通讯录文件。'	//分享的详细描述
                };
                rrShareOnclick(rrShareParam);
            }
        </script>
    </div>--%>
    <p style="text-align: center; text-shadow: initial">
        <strong>
            <button onclick="document.getElementById('LoginStatus').disabled = true; document.location.href='/Account/Login.aspx';return false;" id="LoginStatus" style="font-size: x-large; height: 40px; width: 220px; margin-top: 0px; font-family: 'Microsoft YaHei UI'">登入并开始导出</button>
        </strong>
    </p>
</asp:Content>
